Subject: [jose] Fwd: New Version Notification for draft-barnes-jose-jsms-00.txt

From: "Richard L. Barnes" <[email-masked]>
Date: Fri, 15 Jun 2012 17:08:17 -0400

Dear JOSE WG,

Like Mr. Manger, once I finally got around to doing a thorough review of the JW* specs, I was kind of puzzled by some of the design decisions.  So I also went through and wrote an alternative format, this time taking a more of a cue from CMS.  A link to the document is below.

Summary of differences:

   o  JSMS is pure JSON, whereas in JWE and JWS only the header
      parameters are represented in JSON.

   o  JSMS allows for full algorithm agility in key agreement, while JWE
      only allows ECDH-ES.

   o  JSMS supports multiple recipients for EncryptedData and
      AuthenticatedData objects via the inclusion of multiple WrappedKey
      objects.  Sending a JWE to multiple recipients requires re-
      encryption of the entire object for each recipient.

   o  The signature and MAC functions of the JWS object are separated
      into SignedData and AuthenticatedData JSMS objects.

   o  JSMS parameters are not integrity-protected, as they are in JWE
      and JWS.

   o  The "typ" and "zip" parameters are not defined in JSMS, but could
      be added without significant change.

   o  JSMS requires that recipients MUST ignore unknown header
      parameters, in order to facilitate extensibility.

I've also thrown together an initial JavaScript implementation (based on NodeJS for some python crypto glue), which is on github:
<https://github.com/bifurcation/jsms>

Comments are very welcome.  

Thanks,
--Richard

Begin forwarded message:

> From: [email-masked]
> Subject: New Version Notification for draft-barnes-jose-jsms-00.txt
> Date: June 15, 2012 4:56:09 PM EDT
> To: [email-masked]
> 
> 
> A new version of I-D, draft-barnes-jose-jsms-00.txt
> has been successfully submitted by Richard Barnes and posted to the
> IETF repository.
> 
> Filename:	 draft-barnes-jose-jsms
> Revision:	 00
> Title:		 JavaScript Message Security Format
> Creation date:	 2012-06-15
> WG ID:		 Individual Submission
> Number of pages: 25
> URL:             http://www.ietf.org/internet-drafts/draft-barnes-jose-jsms-00.txt
> Status:          http://datatracker.ietf.org/doc/draft-barnes-jose-jsms
> Htmlized:        http://tools.ietf.org/html/draft-barnes-jose-jsms-00
> 
> 
> Abstract:
>   Many applications require the ability to send cryptographically
>   secured messages.  While the IETF has defined a number of formats for
>   such messages (e.g.  CMS) those formats use encodings which are not
>   easy to use in modern applications.  This document describes the
>   JavaScript Message Security format (JSMS), a new cryptographic
>   message format which is based on JavaScript Object Notation (JSON)
>   and thus is easy for many applications to generate and parse.
> 
> 
> 
> 
> The IETF Secretariat